"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.run = void 0;
const config_1 = require("./config");
const process_1 = require("./process");
const run = async () => {
    const config = await (0, config_1.readConfig)();
    const packages = Object.entries(config);
    await Promise.all(packages.map(([pkg, options]) => (0, process_1.processPackage)(pkg, options))).catch(console.error);
    if (packages.length === 0) {
        console.error('No packages were modified');
        process.exitCode = 1;
        process.exit();
    }
    console.log(`Typed ${packages.length} packages. (${packages.map((p) => p[0]).join(', ')})`);
};
exports.run = run;
//# sourceMappingURL=index.js.map