"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.readPackageJson = exports.editPackageJson = void 0;
const promises_1 = __importDefault(require("fs/promises"));
const path_1 = __importDefault(require("path"));
const editPackageJson = async (folderPath, editor) => {
    const [packagePath, content] = await (0, exports.readPackageJson)(folderPath);
    const newContent = editor(content);
    await promises_1.default.writeFile(packagePath, JSON.stringify(newContent, null, 2));
};
exports.editPackageJson = editPackageJson;
const readPackageJson = async (folderPath) => {
    const packagePath = path_1.default.join(folderPath, 'package.json');
    const content = await (await promises_1.default.readFile(packagePath)).toString();
    return [packagePath, JSON.parse(content.toString())];
};
exports.readPackageJson = readPackageJson;
//# sourceMappingURL=package-editor.js.map